#
# spec file for package opennebula (Version 3.4.1)
# this code base is under development
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

Name:          opennebula
Version:       3.8.4
Release:       1
License:       Apache-2.0
Summary:   OpenNebula
URL:       http://opennebula.org
Group:         Productivity/Networking/System
Source0:       opennebula-3.8.4.tar.gz
Source1:       sunstone.init
Source6:       ozones.init
Source8:       onetmpdirs

BuildRequires: post-build-checks
BuildRequires: gcc-c++
# Requires Oracle's JAVA, but not available due to license problems
# BuildRequires: java-devel
BuildRequires: libcurl-devel
BuildRequires: libxml2-devel
BuildRequires: libxmlrpc-c-devel    >= 1.06
BuildRequires: libopenssl-devel     >= 0.9
BuildRequires: mysql-devel
BuildRequires: openssh
BuildRequires: pkg-config
BuildRequires: pwgen
BuildRequires: ruby                 >= 1.8.6
BuildRequires: scons                >= 0.97
BuildRequires: sqlite3-devel        >= 3.5.2
BuildRequires: xmlrpc-c             >= 1.06
%if 0%{?suse_version} > 1140
BuildRequires: systemd
%endif
Requires:      openssl              >= 0.9
Requires:      ruby                 >= 1.8.6
Requires:      openssh
Requires:      pwgen
Requires:      sqlite3              >= 3.5.2
Requires:      rubygem-nokogiri
Requires:      rubygem-sqlite3
Requires:      xmlrpc-c             >= 1.06
Requires:      wget
Requires:      curl
%{?systemd_requires}
Recommends:    mysql
Recommends:    nfs-kernel-server
Recommends:    ypserv
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root

%description
OpenNebula.org is an open-source project aimed at building the industry
standard open source cloud computing tool to manage the complexity and
heterogeneity of distributed data center infrastructures.

The OpenNebula.org Project is maintained and driven by the community. The
OpenNebula.org community has thousands of users, contributors, and supporters,
who interact through various online email lists, blogs and innovative projects
to support each other.

%package devel
Summary:  Development files for %{name}
Group:    Development/Libraries/Other
Requires: %{name} = %{version}

%description devel
The %{name} devel package contains man pages and examples.

%package zones
Summary: Manage multy tenancy
Group:   Productivity/Networking/System
Requires: %{name} = %{version}
Requires: apache2
Requires: rubygem-rack

%description zones
The OpenNebula Zones (oZones) component allows for the centralized management
of multiple instances of OpenNebula (zones), managing in turn potentially
different administrative domains.

%package sunstone
Summary: Browser based UI to administer an OpenNebulaCloud
Group:   Productivity/Networking/System
Requires: %{name} = %{version}

%description sunstone
sunstone if the web base UI to manage a deployed OpenNebula Cloud

# %package java
# Summary: Java interface to OpenNebula Cloud API
# Group:   Productivity/Networking/System
# Requires: java

# %description java
# Java interface to OpenNebula Cloud API

%prep
%setup -q

%build
scons sqlite_db=/usr xmlrpc=/usr mysql=yes %{?_smp_mflags}
# # Building java interface
# cd src/oca/java
# ./build.sh -d

%install
export DESTDIR=%{buildroot}
export NO_BRP_CHECK_BYTECODE_VERSION=true
./install.sh
# Handle init system differences
%if 0%{?suse_version} > 1140
    install  -p  -D  -m  755  share/pkgs/openSUSE/systemd/onedsetup              %{buildroot}%{_sbindir}/onedsetup
    install  -p  -D  -m  755  share/pkgs/openSUSE/systemd/one.service            %{buildroot}%{_unitdir}/one.service
    install  -p  -D  -m  755  share/pkgs/openSUSE/systemd/one_scheduler.service  %{buildroot}%{_unitdir}/one_scheduler.service
    install  -p  -D  -m  755  share/pkgs/openSUSE/systemd/sunstone.service       %{buildroot}%{_unitdir}/sunstone.service
    install  -p  -D  -m  755  share/pkgs/openSUSE/systemd/ozones.service         %{buildroot}%{_unitdir}/ozones.service
%else
    %{__mkdir} %{buildroot}/etc/init.d
    %{__mv} %{buildroot}%{_bindir}/one %{buildroot}/etc/init.d
    install -p -D -m 755 %{SOURCE1} %{buildroot}%{_initrddir}/sunstone
    install -p -D -m 755 %{SOURCE6} %{buildroot}%{_initrddir}/ozones
%endif


%if 0%{?suse_version} > 1120 && 0%{?suse_version} <= 1140
    install -p -D -m 755 %{SOURCE8} %{buildroot}%{_sysconfdir}/tmpdirs.d/30_One
%endif

%if 0%{?suse_version} > 1140
    install -p -D -m 644 share/pkgs/openSUSE/systemd/onetmpdirs %{buildroot}/usr/lib/tmpfiles.d/one.conf
%endif

# install -p -D -m 644 src/oca/java/jar/org.opennebula.client.jar %{buildroot}%{_javadir}/org.opennebula.client.jar


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc LICENSE
%doc NOTICE
%config %{_sysconfdir}/one/auth/*
%config %{_sysconfdir}/one/cli/*
%config %{_sysconfdir}/one/defaultrc
%config %{_sysconfdir}/one/ec2query_templates/*
%config %{_sysconfdir}/one/econe.conf
%config %{_sysconfdir}/one/group.default
%config %{_sysconfdir}/one/hm/*
%config %{_sysconfdir}/one/im_ec2/*
%config %{_sysconfdir}/one/occi*
%config %{_sysconfdir}/one/oned.conf
%config %{_sysconfdir}/one/sched.conf
%config %{_sysconfdir}/one/vmm_*
%config %{_sysconfdir}/one/vmwarerc
%if 0%{?suse_version} > 1120 && 0%{?suse_version} <= 1140
    %config %{_sysconfdir}/tmpdirs.d/30_One
%endif
%if 0%{?suse_version} > 1140
    %config /usr/lib/tmpfiles.d/one.conf
%endif
%{_bindir}/econe*
%{_bindir}/oc*
%{_bindir}/on*
%{_bindir}/mm_sched
%{_bindir}/tty_expect
/usr/lib/one/mads/*
/usr/lib/one/sh/scripts_common.sh
/usr/lib/one/ruby/*
/var/lib/one/*
%if 0%{?suse_version} > 1140
    %{_sbindir}/onedsetup
    %{_unitdir}/one.service
    %{_unitdir}/one_scheduler.service
%else
    /etc/init.d/one
%endif
%dir %{_sysconfdir}/one
%dir /usr/lib/one
%dir /usr/lib/one/mads
%dir /usr/lib/one/ruby
%dir /usr/lib/one/sh
%dir /var/lib/one

%files devel
%defattr(-,root,root)
%doc README.md
%{_mandir}/man1/*
%{_datadir}/one/install_*
%{_datadir}/one/examples/*
%dir %{_datadir}/one
%dir %{_datadir}/one/examples

%files zones
%defattr(-,root,root,-)
%config %{_sysconfdir}/one/ozones-server.conf
/usr/lib/one/ozones/*
%if 0%{?suse_version} > 1140
    %{_unitdir}/ozones.service
%else
    /etc/init.d/ozones
%endif
%{_bindir}/ozones-server
%dir /usr/lib/one/ozones

%files sunstone
%defattr(-,root,root,-)
%config %{_sysconfdir}/one/sunstone*
/usr/lib/one/sunstone/*
%if 0%{?suse_version} > 1140
    %{_unitdir}/sunstone.service
%else
    /etc/init.d/sunstone
%endif
%{_bindir}/sunstone-server
%dir /usr/lib/one/sunstone


# %files java
# %defattr(-,root,root)
# %{_javadir}/org.opennebula.client.jar


%pre
# cloud administrator setup
if ! getent passwd oneadmin &> /dev/null ; then
  echo "Creating oneadmin user"
  /usr/sbin/groupadd cloud
  ONEPWD=$(/usr/bin/pwgen 40 1)
  /usr/sbin/useradd -m -c "OpenNebula Cloud Admin" -d /var/lib/one -g cloud -p $ONEPWD oneadmin
fi

%post
if [ ! -d /var/lib/one/.ssh ] ; then
  %{__mkdir} /var/lib/one/.ssh
fi
# Setup the ssh infrastructure for the cloud
if [ ! -f /var/lib/one/.ssh/id_rsa ]; then
    /usr/bin/ssh-keygen -q -t rsa -f /var/lib/one/.ssh/id_rsa -N ''
fi
/bin/cp /var/lib/one/.ssh/id_rsa.pub /var/lib/one/.ssh/authorized_keys
echo "Host *" >> /var/lib/one/.ssh/config
echo "    StrictHostKeyChecking no" >> /var/lib/one/.ssh/config
# set the ownership of the management scripts
/bin/chown -R oneadmin:cloud /var/lib/one
if [ ! -d /var/log/one ]; then
  %{__mkdir} /var/log/one
fi
if [ ! -d /var/lock/one ]; then
  %{__mkdir} /var/lock/one
fi
if [ ! -d /var/run/one ]; then
  %{__mkdir} /var/run/one
fi
/bin/chown -R oneadmin:cloud /var/log/one
/bin/chown -R oneadmin:cloud /var/lock/one
/bin/chown -R oneadmin:cloud /var/run/one

%changelog
* Wed Jun 12 2013 OpenNebula Team <contact@opennebula.org> - 3.8.4
- Adapted the package from Robert Schweikert openSUSE build
service: https://build.opensuse.org/package/files?package=opennebula&project=Virtualization:Cloud:OpenNebula
